{ ***************************************************************************
      :
       DMAALL, STREAM_DMA_1056
       LCARD_AD.DLL, SHOW16.DLL
   ************************************************************************** }

program _10561250;
uses
    WinTypes, WinProcs, LCard_ad, Show16
{$ifdef VER70}
    , Win31
{$endif}
;

const
    MyN=32;
    Nch=MyN div 2;
    MyX=256;
    MyY=2000;
    SoftCmd=4;
    TtlInStreamCmd_1056=4;

type
    TData         =array[0..MyX*MyN-1] of word;
    TPoint        =array[0..MyX*MyN-1] of PointType;
    TPointNumber  =array[0..MyN-1] of word;
    PTData        =^TData;
    PTPoint       =^TPoint;
    PPTPoint      =^PTPoint;
    PTPointNumber =^TPointNumber;
    PPTPointNumber=^PTPointNumber;

const
    SizeMyBuffer=sizeof(TData);

var
    i, j       :word;
    Point      :TPoint;
    PointNumber:TPointNumber;
    PLinear    :PTData;
    PPhysical  :PTData;
    Channels   :array[0..Nch-1] of word;
    DmaChannel :TDmaChannel;


{*****************************************************************************}
function MyMakeData:WordBool;export;
Begin
    for i:=0 to Nch-1 do
        for j:=0 to MyX-1 do Point[i*MyX+j].y:=((PLinear^[j] shr i) and 1)*(-MyY)+(MyY shr 1);
    for i:=0 to Nch-1 do
        for j:=0 to MyX-1 do Point[MyX*Nch+i*MyX+j].y:=-integer(PLinear^[MyX*Nch+j*Nch+i]);
End;


{*****************************************************************************}
Begin
    PMakeData:=@_MakeData;

    FillChar(DmaChannel, sizeof(TDmaChannel), 0);
    DmaChannel.DDS.Size:=SizeMyBuffer;
    ALLOCATEBUFFER(@DmaChannel, 0);
    if DmaChannel.PLinear=NIL then Halt(255);

    Rate:=100;
    Channel:=1;
    for i:=0 to Nch-1 do Channels[i]:=i;

    PCount^:=MyN;
    PMaxX^:=MyX;
    PMaxY^:=MyY;
    PPenWidth^:=1;
    for i:=0 to MyN-1 do
    Begin
        PointNumber[i]:=MyX;
        for j:=0 to MyX-1 do Point[i*MyX+j].x:=j;
    End;
    PTPoint(PPP^):=@Point;
    PTPointNumber(PPD^):=@PointNumber;
    PMakeData^:=MyMakeData;

    PLinear:=PTData(ptr(AllocSelector(seg(PPP^)), 0));
    SetSelectorBase(seg(PLinear^), longint(DmaChannel.PLinear));
    SetSelectorLimit(seg(PLinear^), DmaChannel.DDS.Size);
    FillChar(PLinear^, SizeMyBuffer, 0);
    PPhysical:=PTData(DmaChannel.DDS.Physical);

    _SEND_COMMAND(TtlInStreamCmd_1056); { STREAM_DMA_1056 }
    _PUT_DATA(Channel);
    _PUT_DATA(Rate);
    asm
        mov al, 8+2
        mov dx, 30Ch
        out dx, al
    End;
    asm
        cli
        out 0D8h, al

        db  66h
        mov ax,   word ptr PPhysical    { mov eax,  word ptr PPhysical }
        db  66h
        shr ax,   1                     { shr eax,  1 }
        out 0C4h, al
        mov al,   ah
        out 0C4h, al

        db  66h
        shr ax,   15                    { shr eax,  15 }
        and al,   0FEh
        out 8Bh,  al

        mov ax,   (SizeMyBuffer/2)-1
        out 0C6h, al
        mov al,   ah
        out 0C6h, al

        mov al,   45h or 10h
        out 0D6h, al

        mov al,   1
        out 0D4h, al                    { Unmask Channel 1 }
        sti
    End;

    SELECT_DEVICE(1);
    _SEND_COMMAND(SoftCmd);             { DMAALL }
    _PUT_DATA(NCh);
    for i:=0 to Nch-1 do _PUT_DATA(Channels[i]);
    _PUT_DATA(Rate);
    asm
        mov al, 8+4
        mov dx, 31Ch
        out dx, al
    End;
    i:=MyX*Nch;
    asm
        cli
        out 0D8h, al

        db  66h
        mov ax,  word ptr PPhysical     { mov eax,  word ptr PPhysical }
        db  66h
        sub bx,   bx                    { sub ebx, ebx }
        mov bx,   i
        db  66h
        shl bx,   1                     { shl ebx,  1 }
        db  66h
        add ax,   bx                    { add eax, ebx }
        db  66h
        shr ax,   1                     { shr eax,  1 }
        out 0C8h, al
        mov al,   ah
        out 0C8h, al

        db  66h
        shr ax,   15                    { shr eax,  15 }
        and al,   0FEh
        out 89h,  al

        mov ax,   i
        dec ax
        out 0CAh, al
        mov al,   ah
        out 0CAh, al

        mov al,   46h or 10h
        out 0D6h, al

        mov al,   2
        out 0D4h, al                    { Unmask Channel 6 }
        sti
    End;

    InstallShow(hInstance, SW_SHOWMAXIMIZED);

    asm
        mov al,   5
        out 0D4h, al                    { Mask Channel 5 }
        mov al,   6
        out 0D4h, al                    { Mask Channel 6 }
    End;

    DMA_OFF;
    FREEBUFFER(@DmaChannel, 0);
    FreeSelector(seg(PLinear^));
End.
