{ ***************************************************************************
      :
       CREATE_CHANNEL_LC201, READ_CALIBR_CC,
       SET_CALIBR_MODE_CC, PROGRAM_FILTER_LC201,
       FORCE_INTER_DELAY_CC, CONFIG_FIFO_CC,
       PROGRAM_USIL_LC201, SET_TRIM_DAC_LC201,
       SOFT_CC, OUTDA_AD8842
       LCARD_32.DLL, SHOW32.DLL
   ************************************************************************** }

program CC32;
uses
    Windows, LCard_32, Show32;

const
    MyN=10;
    MyX=512;
    MyY=2000;
    MODES_201_REAL=5;

type
    TData         =array[0..MyX*MyN-1] of word;
    TPoint        =array[0..MyX*MyN-1] of PointType;
    TPointNumber  =array[0..MyN-1] of dword;
    PTPoint       =^TPoint;
    PPTPoint      =^PTPoint;
    PTPointNumber =^TPointNumber;
    PPTPointNumber=^PTPointNumber;

var
    i, j       :cardinal;
    Data       :TData;
    Channels   :array[0..23] of word;
    Point      :TPoint;
    PointNumber:TPointNumber;


{*****************************************************************************}
procedure SET_TRIM_DAC_LC201(Slot_201:cardinal;Channel:cardinal;Gain:cardinal);
Begin
   OUTDA_AD8842(Slot_201, Channel*2+0, READ_FLASH_CC(Slot_201, 4*2*MODES_201_REAL+2+Gain*4+Channel) and $FF00 shr 8);
   OUTDA_AD8842(Slot_201, Channel*2+1, READ_FLASH_CC(Slot_201, 4*2*MODES_201_REAL+2+Gain*4+Channel) and $FF);
End;


{*****************************************************************************}
function MyMakeData:LongBool;stdcall;
Begin
    SOFT_CC(7, MyN, Channels, MyX, Rate*MyN, Data);

    for i:=0 to MyN-1 do
        for j:=0 to MyX-1 do
            Point[i*MyX+j].y:=-smallint(Data[j*MyN+i]);

    MyMakeData:=TRUE;
End;


{*****************************************************************************}
Begin
    PMakeData:=PPointer(PPointer(longint(@_MakeData)+2)^)^;

{    SELECT_DEVICE(1);}

    Rate:=10;

    PCount^:=MyN;
    PMaxX^:=MyX;
    PMaxY^:=MyY;
    PPenWidth^:=1;
    for i:=0 to MyN-1 do
    Begin
        PointNumber[i]:=MyX;
        for j:=0 to MyX-1 do Point[i*MyX+j].x:=j;
    End;
    PTPoint(PPP^):=@Point;
    PTPointNumber(PPD^):=@PointNumber;
    PMakeData^:=MyMakeData;

    for i:=0 to 3 do
    Begin
        Channels[i*2+0]:=4;
        Channels[i*2+1]:=word(CREATE_CHANNEL_LC201(i, 1, 1, 0));
        Channels[i*2+0+8]:=5;
        Channels[i*2+1+8]:=word(CREATE_CHANNEL_LC201(i, 1, 1, 0));
        Channels[i*2+0+16]:=6;
        Channels[i*2+1+16]:=word(CREATE_CHANNEL_LC201(i, 1, 1, 0));
    End;

    READ_CALIBR_CC;
    SET_CALIBR_MODE_CC(0);
    PROGRAM_FILTER_LC201(4, 5000);
    PROGRAM_FILTER_LC201(5, 5000);
    PROGRAM_FILTER_LC201(6, 5000);
    FORCE_INTER_DELAY_CC(40);
    CONFIG_FIFO_CC(2, 2);

    for i:=0 to 3 do
    Begin
        PROGRAM_USIL_LC201(4, i, 1);
        SET_TRIM_DAC_LC201(4, i, 1);
        PROGRAM_USIL_LC201(5, i, 1);
        SET_TRIM_DAC_LC201(5, i, 1);
        PROGRAM_USIL_LC201(6, i, 1);
        SET_TRIM_DAC_LC201(6, i, 1);
    End;

    InstallShow(hInstance, SW_SHOWMAXIMIZED);
End.
