//--------------------------------------------------------------------------
//    :
//     ALLOCATEBUFFER, FREEBUFFER,
//     DMA_TEST, DMA_OFF,
//     DMAONE, DADMASTREAM,
//     DMA_COUNTER_OUT, DMA_COUNTER_IN
//    32 BIT  LCARD_32.DLL
//--------------------------------------------------------------------------

#include <stdio.h>
#include <conio.h>
#include "lcard_ad.h"

#define  MyBuffer     128*1024   /* 128 KW */
#define  SizeMyBuffer MyBuffer*2 /* 256 KB */

unsigned i;


/* ********************************************************************** */
void PrintData(WORD* PLinear)
{
    printf("Data = ");
    for(int i=0;i<20;i++) printf("%X ", PLinear[i]);
    printf("\n");
};


/* ********************************************************************** */
int main()
{
  WORD  Channel;
  int   Rate;
  int   Npoint;
  WORD  Channels[16]={0, 2};
  int   Nch;
  WORD* PLinear;
  WORD* PPhysical;

//    SELECT_DEVICE(1);

    ALLOCATEBUFFER(SizeMyBuffer, &PLinear, &PPhysical);
    printf("PLinear:  %Xh\n", PLinear);
    printf("Physical: %Xh\n", PPhysical);
    if(PLinear==NULL)
    {
        printf("Unable To Allocate Physical Memory.");
        return 255;
    };

    for(i=0;i<MyBuffer;i++) PLinear[i]=0x55AA;
    PrintData(PLinear);

    Rate=10;
    Npoint=16384;
    Channel=0;
    DMAONE(PPhysical, Npoint, Channel, Rate, 0);
    PrintData(PLinear+100);

    while (!DMA_TEST())
    {
        printf("DMA Count = %u\n", DMA_COUNTER_IN());
        Sleep(10);
    };

    PrintData(PLinear+100);
    printf("\n");
    DMA_OFF();


    printf("Press Any Key.\n");
    getch();


    for(i=0;i<MyBuffer;i++) PLinear[i]=(WORD)(i & 0x3FF);
    Rate=50;
    Npoint=4096;
    Channel=0;
    DADMASTREAM(PPhysical, Npoint, Rate, Channel);

    while (!DMA_TEST())
    {
        printf("DMA Count = %u\n", DMA_COUNTER_OUT());
        Sleep(10);
    };

    DMA_OFF();


    printf("Press Any Key.\n");
    getch();


    for(i=0;i<MyBuffer;i++) PLinear[i]=0xA5A5;
    Nch=2;
    Rate=100;
    Npoint=32768;
    DMA_ALL_DA(PPhysical, Npoint, Channels, Nch, Rate, 1,
              (PPhysical+Npoint*Nch), Npoint*2, 1, 0);

    while (!kbhit())
    {
        printf("DMA Count = %Xh\n", DMA_COUNTER_IN());
        printf("DMA Count = %Xh\n", DMA_COUNTER_OUT());
        PrintData(PLinear+1000);
        printf("Press Any Key.\n");
        Sleep(1000);
    };

    DMA_OFF();


    FREEBUFFER(PLinear);

  return(0);
};
