//--------------------------------------------------------------------------
//    :
//    SET_FIFO_PARAMETERS_E330, SET_SOFT_PARM_E330, SET_TIME_PARAMETERS_E330
//    IRQ_SLOW_START_E330, READ_DATA, RESET_IRQ, STOP_INTR
//     LCARD_??.DLL, SHOW??.DLL
//--------------------------------------------------------------------------

#define  MyN 4
#define  MyX 1024
#define  MyY 2000

#include "lcard_ad.h"
#pragma  hdrstop
#include "show.h"

int GetingDataCount=0;
#ifdef WIN32
BOOL Is_NT=((long)GetVersion())>0;
#endif

/* ********************************************************************** */
//    DSP
HANDLER_TYPE IrqHandler(HANDLER_PARM)
{
  int i;

    //      DSP
    if(GetingDataCount>=MyX*MyN) for(i=0;i<MyN;i++) READ_DATA(); else
    {
        for(i=0;i<MyN;i++) Data[GetingDataCount+i]=(WORD)READ_DATA();
        GetingDataCount=GetingDataCount+MyN;
    };

#ifdef WIN32
    if(!Is_NT) RESET_IRQ();
#else
    RESET_IRQ();
#endif
};


/* ********************************************************************** */
TMyMakeData MyMakeData()
{
    if(GetingDataCount>=MyX*MyN)
    {
        for(int i=0;i<MyN;i++)
            for(int j=0;j<MyX;j++)
                Point[i*MyX+j].y=-(short)Data[j*MyN+i];

        GetingDataCount=0;

      return TRUE;
    };

  return FALSE;
};


/* ********************************************************************** */
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR, int)
{
  unsigned i, j;

//    SELECT_DEVICE(1);

    Nch=MyN;
    Rate=500;
    for(i=0;i<MyN;i++) Channels[i]=i;

    MaxX=MyX;
    MaxY=MyY;
    Count=MyN;
    for(i=0;i<MyN;i++)
    {
        PointNumber[i]=MyX;
        for(j=0;j<MyX;j++) Point[i*MyX+j].x=j;
    };
    PP=Point;
    PD=PointNumber;
    MakeData=MyMakeData;

    SET_SOFT_PARM_E330(Nch, Channels);
    SET_TIME_PARAMETERS_E330(Rate);
    IRQ_SLOW_START_E330(2, IrqHandler);

    InstallShow(hInst, SW_SHOWMAXIMIZED);

    STOP_INTR();                  //   

  return Msg.wParam;
};
