//--------------------------------------------------------------------------
//    :
//    SET_TIMER_SCALE, CONFIG_2FIFO_TYPE,
//    STREAM_FIFO2_BEGIN, RESET_IRQ, STOP_INTR
//     LCARD_??.DLL, SHOW??.DLL
//--------------------------------------------------------------------------

#define  NN  4
#define  MyN 4
#define  MyX 1024
#define  MyY 2000

#include "lcard_ad.h"
#pragma  hdrstop
#include "show.h"

int  GetingDataCount=0;
int  EmptyCount=0;
WORD Empty[MyX/NN];
#ifdef WIN32
BOOL Is_NT=((long)GetVersion())>0;
#endif

/* ********************************************************************** */
//    DSP
HANDLER_TYPE IrqHandler(HANDLER_PARM)
{
    //      DSP
    if((GetingDataCount<MyN*NN)&&(EmptyCount==0)) READ_FIFO(Data+MyX/NN*GetingDataCount++, MyX/NN); else
    {
        READ_FIFO(Empty, MyX/NN);
        if(++EmptyCount>=MyN*NN) EmptyCount=0;
    };

#ifdef WIN32
    if(!Is_NT) RESET_IRQ();
#else
    RESET_IRQ();
#endif
};


/* ********************************************************************** */
TMyMakeData MyMakeData()
{
    if(GetingDataCount>=MyN*NN)
    {
        for(int i=0;i<MyN;i++)
            for(int j=0;j<MyX;j++)
                Point[i*MyX+j].y=-(short)Data[j*MyN+i];

        GetingDataCount=0;

      return TRUE;
    };

  return FALSE;
};


/* ********************************************************************** */
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR, int)
{
  unsigned i, j;

//    SELECT_DEVICE(1);

    Nch=MyN;
    Rate=1000;
    for(i=0;i<MyN;i++) Channels[i]=i;

    MaxX=MyX;
    MaxY=MyY;
    Count=MyN;
    for(i=0;i<MyN;i++)
    {
        PointNumber[i]=MyX;
        for(j=0;j<MyX;j++) Point[i*MyX+j].x=j;
    };
    PP=Point;
    PD=PointNumber;
    MakeData=MyMakeData;

    SET_TIMER_SCALE(10);
    CONFIG_2FIFO_TYPE(1, MyX/NN);
    STREAM_FIFO2_BEGIN(Rate, IrqHandler, Channels, Nch);

    InstallShow(hInst, SW_SHOWMAXIMIZED);

    STOP_INTR();                  //   
    CONFIG_2FIFO_TYPE(0, 0);

  return Msg.wParam;
};
