//--------------------------------------------------------------------------
//    :
// SET_TIMER_SCALE, CONFIG_2FIFO_TYPE,
// READ_FIFO, RESET_IRQ,
// STREAM_FIFO2_BEGIN, STOP_INTR
//    32 BIT  LCARD_32.DLL
//--------------------------------------------------------------------------

#include <conio.h>
#include <stdio.h>
#include "lcard_ad.h"

#define  MyN  4
#define  MyX  256
#define  Rate 100

DWORD     OldTime;
PTFastIrq PP;
WORD      Data[MyX];
WORD      Channels[16]={0, 1, 2};
BOOL Is_NT=((long)GetVersion())>0;


/* ********************************************************************** */
//    DSP
HANDLER_TYPE IrqHandler(HANDLER_PARM)
{
    //      DSP
    READ_FIFO(Data, MyX);
    if(!Is_NT) RESET_IRQ();
};


/* ********************************************************************** */
int main()
{
//    SELECT_DEVICE(1);

    SET_TIMER_SCALE(10);
    CONFIG_2FIFO_TYPE(1, MyX);
    PP=(PTFastIrq)STREAM_FIFO2_BEGIN(Rate, IrqHandler, Channels, MyN);

    printf("Count:    %d\n", (*PP).Reenter.Count);
    printf("Missing:  %d\n", (*PP).Reenter.Missing);
    printf("IrqCount: %d\n", (*PP).IrqCount);

    OldTime=GetCurrentTime();
    Sleep(1000);
    printf("Time: %d\n", GetCurrentTime()-OldTime);

    printf("Count:    %d\n", (*PP).Reenter.Count);
    printf("Missing:  %d\n", (*PP).Reenter.Missing);
    printf("IrqCount: %d\n", (*PP).IrqCount);
    printf("Must Be:  %d\n", 1000000*MyN/Rate/MyX);

    STOP_INTR();                  //   
    CONFIG_2FIFO_TYPE(0, 0);

    printf("Press Any Key.\n");
    getch();

  return(0);
};
