//--------------------------------------------------------------------------
//    :
//
//     LCARD_??.DLL, SHOW??.DLL
//--------------------------------------------------------------------------

#define  MyN 4
#define  MyX 1000
#define  MyY 4000

#include "lcard_ad.h"
#pragma  hdrstop
#include "show.h"

int IrqArraySize=MyX*MyN;
int HalfSize=IrqArraySize/2;
int IrqIndex=0;
int GlobalIntSwitch=0;
int Counter;

#ifdef WIN32
BOOL Is_NT=((long)GetVersion())>0;
#endif


/* ********************************************************************** */
//    DSP
HANDLER_TYPE IrqHandler(HANDLER_PARM)
{
    if(IrqIndex>=IrqArraySize) IrqIndex=0;
    GET_FAST_SOFT_IRQ_DATA(Data+IrqIndex, HalfSize);
    GlobalIntSwitch=1;
    IrqIndex+=HalfSize;
    Counter++;
#ifdef WIN32
    if(!Is_NT) RESET_IRQ();
#else
    RESET_IRQ();
#endif
};


/* ********************************************************************** */
TMyMakeData MyMakeData()
{
  unsigned i, j;

    if(!GlobalIntSwitch) return FALSE;

    for(i=0;i<MyN;i++)
        for(j=0;j<MyX;j++)
            Point[i*MyX+j].y=-(short)Data[j*MyN+i];

    GlobalIntSwitch =0;

  return TRUE;
};


/* ********************************************************************** */
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR, int)
{
  unsigned i, j;
  WORD Slot=1;

//    SELECT_DEVICE(1);

    Counter=0;
    MaxX=MyX;
    MaxY=MyY;
    Count=MyN;
    for(i=0;i<MyN;i++) PointNumber[i]=MyX;
    PP=Point;
    PD=PointNumber;
    MakeData=MyMakeData;
    for(i=0;i<MyN;i++) for(j=0;j<MyX;j++) Point[i*MyX+j].x=j;

    Nch=MyN;
    for(j=0;j<4;j++)
    {
        Channels[j*2]=Slot;
        Channels[j*2+1]=(WORD)j;
    };

    SOFT_CONFIG_CC(7, Nch, Channels, 12*Nch);
    SET_FIFO_SIZE_CC(IrqArraySize);
    FAST_SOFT_IRQ_START_CC(IrqHandler);

    InstallShow(hInst, SW_SHOWMAXIMIZED);

    FAST_SOFT_IRQ_STOP_CC();
    STOP_INTR();

  return Msg.wParam;
};
