{ ***************************************************************************
      :
       CREATE_CHANNEL_LC102, READ_CALIBR_CC,
       FORCE_INTER_DELAY_CC, CONFIG_FIFO_CC,
       SOFT_CC, SET_CALIBR_MODE_CC
       LCARD_32.DLL, SHOW32.DLL
   ************************************************************************** }

program Test102;
uses
    Windows, LCard_32, Show32;

const
    MyN=4;
    MyX=1024;
    MyY=5000;
    errTimeout=$20002002;

type
    TData         =array[0..MyX*MyN-1] of word;
    TPoint        =array[0..MyX*MyN-1] of PointType;
    TPointNumber  =array[0..MyN-1] of dword;
    PTPoint       =^TPoint;
    PPTPoint      =^PTPoint;
    PTPointNumber =^TPointNumber;
    PPTPointNumber=^PTPointNumber;

var
    i, j       :cardinal;
    Slot102    :cardinal;
    Slot301    :cardinal;
    Data       :TData;
    Channels   :array[0..23] of word;
    Point      :TPoint;
    PointNumber:TPointNumber;

{       . }
{
    - ,   
         ,
    100 -   .
    101 -    102      .
    102 -         
        .
    IDCANCEL -         
        .
    0   -         ,
       4     
         ,   
       .
    -1  -   
      errErrorDialogBoxParam,     
     0  -1       .
    (  ) -   
      errUnknownErrorDialogBoxParam,    
      0  -1       
      .
            
       102.
           :
        GET_ERROR_HANDLER
        SET_ERROR_HANDLER
        GET_WANT_SEE
        SET_WANT_SEE
        GET_TIMEOUT
        SET_TIMEOUT
}

{*****************************************************************************}
function MyErrorHandler(Error:DWORD; Info:DWORD):integer;stdcall;
Begin
    case Error of
        errTimeout:
        Begin
            MessageBox(0, 'Error', 'My Error', 0);
{    Crait,   . }
{          main  . }
        End;
    End;

    MyErrorHandler:=102;
End;


{*****************************************************************************}
function MyMakeData:LongBool;stdcall;
Begin
    SOFT_CC(Slot301, MyN, Channels, MyX, Rate*MyN, Data);

    for i:=0 to MyN-1 do
        for j:=0 to MyX-1 do
            Point[i*MyX+j].y:=-smallint(Data[j*MyN+i]);

    MyMakeData:=TRUE;
End;


{*****************************************************************************}
Begin
    PMakeData:=PPointer(PPointer(longint(@_MakeData)+2)^)^;

//    SELECT_DEVICE(1);

    Rate:=20;

    PCount^:=MyN;
    PMaxX^:=MyX;
    PMaxY^:=MyY;
    PPenWidth^:=1;
    for i:=0 to MyN-1 do
    Begin
        PointNumber[i]:=MyX;
        for j:=0 to MyX-1 do Point[i*MyX+j].x:=j;
    End;
    PTPoint(PPP^):=@Point;
    PTPointNumber(PPD^):=@PointNumber;
    PMakeData^:=MyMakeData;

    READ_CALIBR_CC;
    SET_CALIBR_MODE_CC(0);

    for i:=0 to 15 do
    Begin
        if READ_FLASH_CC(i, 0)=102 then Slot102:=i;
        if READ_FLASH_CC(i, 0)=301 then Slot301:=i;
    End;

    for i:=0 to MyN do
    Begin
        Channels[i*2+0]:=Slot102;
        Channels[i*2+1]:=word(CREATE_CHANNEL_LC102(i, 0, 0));
    End;

    FORCE_INTER_DELAY_CC(40);
    CONFIG_FIFO_CC(2, 3);
{
             MyErrorHandler
      .
}
    InstallShow(hInstance, SW_SHOWMAXIMIZED);
End.
